import serial                                           #import serial 
import matplotlib.pyplot as plt                         #import matplot
from drawnow import *                                   #import drawnow as *
import time                                             #import time 

pitch = []                                              # Make empty list to store data
roll = []                                               # Make empty list to store data
plt.ion()                                               # Define intercative mode for live plotting
ser = serial.Serial('COM3', baudrate = 115200)          # Open Serial port in which the receiver is sending data
cntr = 0                                                # Counter for of data collected 
mins = 0                                                # Acts like a Stopwatch
time.sleep(5)                                           # Wait 5 sec for the mpu to calibrate and setup of the tranceivers
plt.show()                                              # Show the plot         
plt.figure()                                            # Start the figure

def plotData() :                                        # Define a set of codes to setup matplot and plot the data 
    plt.ylim(0.001, 180)                                # Set limits for the gyro 
    plt.title('MPU_6050 wireless plotting')             # Title of the plot
    plt.grid(True)                                      # Show grid
    plt.ylabel('roll and pitch')                        # Label for the y axis
    plt.plot(roll, 'ro-', label='Roll')                 # Plot roll (red)
    plt.legend(loc='upper left')                        # Show Legend and define its location
    plt2=plt.twinx()                                    # Make another wave for the roll
    plt2.plot(pitch, 'b^-', label='Pitch')              # Plot pitch (blue)
    plt2.legend(loc='lower left')                       # Show Legend and define its location
    plt2.ticklabel_format(useOffset=False)              # Disable auto-scalling in matplot


while True :                                            # While loop which runs infintly 
        data = ser.readline().decode("utf-8")           # Import all the data into "data" 
        dataArray = data.split(",")                     # Split the data into x and y axis into dataArray[1] and dataArray[0] respectively 
        x = float (dataArray[1])                        # Convert the string into a float as 'x' so we can make use out of the data 
        y = float (dataArray[0])                        # Convert the string into a float as 'y' so we can make use out of the data 
        time.sleep(0.1)                                 # Sleep for 0.1 second so matplot has time to import data (avoid crashing of the plotter)
        print (x, ",", y, "  ", cntr)                   # Print x , y , counter 
        tic = time.perf_counter()
        plt.pause(0.01)                                 # Pause the plot for 0.1 seconds too give time for matplot to import data
        pitch.append(y)                                 # Append x into "roll" for plotting
        roll.append(x)                                  # Append y into "pitch" for plotting
        cntr = cntr + 1                                 # Add + 1 to counter every time the loop is run also acts as a timer as data importion rate is almost 1/1 sec  
        drawnow(plotData)                               # Draw the plot
        if (cntr>20):                                   # If the counter goes above 30
            pitch.pop(0)                                # Delete the oldest indexes from pitch to avoid max index range 
            roll.pop(0)                                 # Delete the oldest indexes from roll to avoid max index range      
            
